/* ================================================================
 * ================================================================
 *
 * Special rendering functionality, such as showing of a robot's target
 *
 * Author: L. Pitonakova (http://lenkaspace.net)
 * License: GNU General Public License. Please credit me when using my work.
 *
 * ================================================================
 * ================================================================
 */
 
 #include "qtLoopFunctions.h"
#include <controllers/baseRobot.h>
#include <argos3/core/simulator/entity/controllable_entity.h>

using namespace argos;

/****************************************/
/****************************************/

QTLoopFunctions::QTLoopFunctions() {
   RegisterUserFunction<QTLoopFunctions,CFootBotEntity>(&QTLoopFunctions::Draw);
}

/****************************************/
/****************************************/

void QTLoopFunctions::Draw(CFootBotEntity& c_entity) {
	BaseRobot& footBot = dynamic_cast<BaseRobot&>(c_entity.GetControllableEntity().GetController());
	//-- draw base odomerty location
	DrawRay(CRay3(CVector3(-footBot.GetRelativeBaseLocation().GetX(), -footBot.GetRelativeBaseLocation().GetY(), 0.1f), CVector3::ZERO),
			CColor::GRAY70);
	//-- draw target deposit odometry location
	BaseRobot::TaskInfo taskInfo = footBot.GetTaskInfo();
    if (!taskInfo.isNull) {
    	DrawRay(CRay3(CVector3(-taskInfo.relLocation.GetX(), -taskInfo.relLocation.GetY(), 0.1f), CVector3::ZERO),
    				CColor::RED);
    }
}

/****************************************/
/****************************************/

REGISTER_QTOPENGL_USER_FUNCTIONS(QTLoopFunctions, "qtLoopFunctions")
